/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

static const char rcsid[] = "$Id: gim_region.cc,v 1.2 2002/08/26 19:24:34 itz Exp $ ";

#ifdef __cplusplus

#include "gim_region.hh"
#include "gim_init_counter.hh"

static gim_init_counter cnt;

gim_region::gim_region(int x_min, int x_max, int y_min, int y_max,
                                       unsigned min_mod, unsigned max_mod,
                                       enum gim_event_kind_t handle)
{
  reg.x_min = x_min;
  reg.x_max = x_max;
  reg.y_min = y_min;
  reg.y_max = y_max;
  reg.min_mod = min_mod;
  reg.max_mod = max_mod;
  reg.handle = handle;
  reg.handler_fun = static_handler;
  reg.active = 0;
  reg.prev = &reg;
  reg.next = &reg;
  reg.extra_data = this;
}

void
gim_region::put(gim_region* after)
{
  gim_put_region(&this->reg, &after->reg);
}

int
gim_region::static_handler(struct gim_event_t* p_ev, struct gim_handler_data_t* hdata)
{
  gim_region* ph = reinterpret_cast<gim_region*>(hdata->extra_data);
  return ph->region_handler(p_ev);
}

int
gim_region::object_handler(struct gim_event_t* p_ev)
{
  gim_handler_data_t* pd = get_data_p();
  pd->extra_data = &reg;
  return gim_region_handler(p_ev, pd);
}

#endif // __cplusplus
